#Matt Gushee had problems with xml:lang

from Xslt import test_harness
from Ft.Lib import TreeCompare

sheet_1 = """\
<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:param name="currentLanguage" select="'en'"/>

  <!-- Removed definition for charEncoding variable. -->

  <xsl:output method="html" encoding="utf-8"/>

  <xsl:template match="/">
  <!--
    <xsl:message><xsl:value-of select="$currentLanguage"/></xsl:message>
  -->
    <xsl:apply-templates select="*[lang($currentLanguage) or not(@xml:lang)]"/>
  </xsl:template>

  <xsl:template match="*">
  <!--
    <xsl:message>Processing: <xsl:value-of select="name()"/></xsl:message>
  -->
    <xsl:copy>
      <xsl:for-each select="@*[name() != 'id']">
	<xsl:copy/>
      </xsl:for-each>
      <xsl:apply-templates
	select="*[lang($currentLanguage) or not(@xml:lang)] | text()"/>
    </xsl:copy>
  </xsl:template>
    
</xsl:stylesheet>"""

source_1 = """\
<?xml version="1.0" encoding="UTF-8"?>
<!--
<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.1//EN"
  "/usr/local/share/xml/xhtml/xhtml11.dtd"
>
-->
<html xmlns="http://www.w3.org/1999/xhtml"
  version="-//W3C//DTD XHTML 1.1//EN"
  xml:lang="en">
  <head>
    <title>Welcome</title>
  </head>

  <body xml:lang="en">
    <h1 xml:lang="en">Welcome</h1>
    <h1 xml:lang="ja">ようこそ</h1>
    <hr/>
    <p xml:lang="en">
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
    <p xml:lang="ja">
会話倶楽部は日本語の会話を練習したい人のためのインフォーマルなグループで
ございます。レベルはかかわらず、新しい会員を大歓迎しております。
</p>
  </body>
</html>
"""

# NOTE - we need to readd source_2 as a Base64 encoded block
# We cannot mix UTF-16 and UTF-8 in the same file
source_2 = """\
"""

source_3 = """\
<?xml version="1.0" encoding="UTF-8"?>
<!--
<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.1//EN"
  "/usr/local/share/xml/xhtml/xhtml11.dtd"
>
-->
<html xmlns="http://www.w3.org/1999/xhtml"
  version="-//W3C//DTD XHTML 1.1//EN"
  xml:lang="en">
  <head>
    <title>Welcome</title>
  </head>

  <body xml:lang="en">
    <h1 xml:lang="en">Welcome</h1>
    <h1 xml:lang="ja">褦</h1>
    <hr />
    <p xml:lang="en">
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
    <p xml:lang="ja">
öܸβäͤΤΥեޥʥ롼פ
ޤ٥Ϥ餺紿ޤƤޤ
</p>
  </body>
</html>
"""

#source_1 + sheet_1 with parameter currentLanguage=en
saxon_output_1 = """\
<html xmlns="http://www.w3.org/1999/xhtml" version="-//W3C//DTD XHTML 1.1//EN" xml:lang="en">
   
   <head>
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
   
      
      <title>Welcome</title>
      
   </head>
   
   
   <body xml:lang="en">
      
      <h1 xml:lang="en">Welcome</h1>
      
      
      <hr>
      
      <p xml:lang="en">
         The Kaiwa Club is an informal group for people who want to practice
         Japanese conversation. We welcome members at all levels of
         proficiency.
         
      </p>
      
      
   </body>
   
</html>"""

#source_1 + sheet_1 with parameter currentLanguage=en
expected_1 = """\
<html xml:lang='en' version='-//W3C//DTD XHTML 1.1//EN'>
  <head>
    <meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
    <title>Welcome</title>
  </head>
  <body xml:lang='en'>
    <h1 xml:lang='en'>Welcome</h1>
    <hr>
    <p xml:lang='en'>
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
  </body>
</html>"""

#source_1 + sheet_1 with parameter currentLanguage=ja
expected_2 = ""

sheet_2 = """\
<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" encoding="utf-8"/>
	<xsl:param name="currentLanguage" select="'en'"/>
	<xsl:template match="/">
		<xsl:apply-templates
			select="*[lang($currentLanguage)
				or not(@xml:lang)]"/>
	</xsl:template>
	<xsl:template match="*">
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:apply-templates
				select="*[lang($currentLanguage)
				or not(@xml:lang)] | text()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="text()">
		<xsl:value-of select="."/>
	</xsl:template>
</xsl:stylesheet>
"""

source_4 = """\
<?xml version="1.0" encoding="utf-8"?>
<!--
<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.1//EN"
  "xhtml11.dtd"
>
-->
<html xmlns="http://www.w3.org/1999/xhtml" version="-//W3C//DTD XHTML
      1.1//EN">
  <head>
    <title>Welcome</title>
  </head>

  <body>
    <h1 xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">Welcome</h1>
    <h1 xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">ようこそ</h1>
    <hr xmlns="http://www.w3.org/1999/xhtml"/>
    <p xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
    <p xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
会話倶楽部は日本語の会話を練習したい人のためのインフォーマルなグループで
ございます。レベルはかかわらず、新しい会員を大歓迎しております。
</p>
  </body>
</html>
"""

# NOTE - we need to readd source_5 as a Base64 encoded block
# We cannot mix UTF-16 and UTF-8 in the same file
source_5 = """\
"""


source_6 = """\
<?xml version="1.0" encoding="euc-jp"?>
<!--
<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.1//EN"
  "xhtml11.dtd"
>
-->
<html xmlns="http://www.w3.org/1999/xhtml" version="-//W3C//DTD XHTML
      1.1//EN">
  <head>
    <title>Welcome</title>
  </head>

  <body>
    <h1 xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">Welcome</h1>
    <h1 xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">褦</h1>
    <hr xmlns="http://www.w3.org/1999/xhtml"/>
    <p xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
    <p xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
öܸβäͤΤΥեޥʥ롼פ
ޤ٥Ϥ餺紿ޤƤޤ
</p>
  </body>
</html>
"""

expected_3 = """\
"""

uche_sheet_1 = """\
<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:param name="currentLanguage" select="'en'"/>

  <xsl:output method="html" encoding="utf-8"/>

  <xsl:template match="*">
    <xsl:choose>
      <xsl:when test="@xml:lang">
        <!-- Don't shift context -->
        <xsl:apply-templates select="." mode="select-lang"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy>
          <xsl:for-each select="@*[name() != 'id']">
            <xsl:copy/>
          </xsl:for-each>
          <xsl:apply-templates/>
        </xsl:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="*" mode="select-lang">
    <xsl:if test="lang($currentLanguage)">
      <xsl:copy>
        <xsl:for-each select="@*[name() != 'id']">
          <xsl:copy/>
        </xsl:for-each>
        <xsl:apply-templates mode="select-lang"/>
      </xsl:copy>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>"""

uche_source_1 = """\
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.1//EN"
  "/usr/local/share/xml/xhtml/xhtml11.dtd"
>
<html xmlns="http://www.w3.org/1999/xhtml"
  version="-//W3C//DTD XHTML 1.1//EN"
>
  <head>
    <title xml:lang="en">Welcome</title>
  </head>

  <body>
    <h1 xml:lang="en">Welcome</h1>
    <h1 xml:lang="ja">ようこそ</h1>
    <hr/>
    <p xml:lang="en">
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
    <p xml:lang="ja">
会話倶楽部は日本語の会話を練習したい人のためのインフォーマルなグループで
ございます。レベルはかかわらず、新しい会員を大歓迎しております。
</p>
  </body>
</html>
"""

uche_expected_1 = """\
<html version='-//W3C//DTD XHTML 1.1//EN'>
  <head>
    <meta http-equiv='Content-Type' content='text/html; charset=utf-8'>
    <title xml:lang='en'>Welcome</title>
  </head>
  <body>
    <h1 xml:lang='en'>Welcome</h1>
    <hr>
    <p xml:lang='en'>
The Kaiwa Club is an informal group for people who want to practice
Japanese conversation. We welcome members at all levels of
proficiency.
</p>
  </body>
</html>"""

uche_expected_2 = """\
<html version='-//W3C//DTD XHTML 1.1//EN'>
  <head>
    <meta http-equiv='Content-Type' content='text/html; charset=utf-8'></head>
  <body>
    <h1 xml:lang="ja">ようこそ</h1>
    <hr>
    <p xml:lang="ja">
会話倶楽部は日本語の会話を練習したい人のためのインフォーマルなグループで
ございます。レベルはかかわらず、新しい会員を大歓迎しております。
</p>
  </body>
</html>"""


def Test(tester):
    tester.startGroup("Selector sheet 1, source 1, lang=en")
    source = test_harness.FileInfo(string=source_1)
    sty = test_harness.FileInfo(string=sheet_1)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected_1,
                                    topLevelParams={('', 'currentLanguage'): 'en'},
                                    )
    xtest.test(tester)
    tester.groupDone()

    # the result is an empty string
    tester.startGroup("Selector sheet 1, source 1, lang=ja")
    source = test_harness.FileInfo(string=source_1)
    sty = test_harness.FileInfo(string=sheet_1)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected_2,
                                    topLevelParams={('', 'currentLanguage'): 'ja'},
                                    compareFunc=cmp,
                                    )
    xtest.test(tester)
    tester.groupDone()

    tester.startGroup("Uche's selector sheet 1, source 1, lang=en")
    source = test_harness.FileInfo(string=uche_source_1)
    sty = test_harness.FileInfo(string=uche_sheet_1)
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    uche_expected_1,
                                    topLevelParams={('', 'currentLanguage'): 'en'},
                                    )
    xtest.test(tester)
    tester.groupDone()

# Don't run until we can try on Matt's console to avoid terminal corruption
##    tester.startGroup("Uche's selector sheet 1, source 1, lang=ja")
##    source = test_harness.FileInfo(string=uche_source_1)
##    sty = test_harness.FileInfo(string=uche_sheet_1)
##    xtest = test_harness.XsltTester(source,
##                                    [sty],
##                                    uche_expected_2,
##                                    topLevelParams={('', 'currentLanguage'): 'ja'},
##                                    )
##    xtest.test(tester)
##    tester.groupDone()

    return
